/**
 * Freqtrade API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2021.12-dev21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import HTTPValidationError from '../model/HTTPValidationError';
import StrategyListResponse from '../model/StrategyListResponse';
import StrategyResponse from '../model/StrategyResponse';

/**
* Strategy service.
* @module ftclient/StrategyApi
* @version 2021.12-dev21
*/
export default class StrategyApi {

    /**
    * Constructs a new StrategyApi. 
    * @alias module:ftclient/StrategyApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }



    /**
     * Get Strategy
     * @param {String} strategy 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/StrategyResponse} and HTTP response
     */
    getStrategyApiV1StrategyStrategyGetWithHttpInfo(strategy) {
      let postBody = null;
      // verify the required parameter 'strategy' is set
      if (strategy === undefined || strategy === null) {
        throw new Error("Missing the required parameter 'strategy' when calling getStrategyApiV1StrategyStrategyGet");
      }

      let pathParams = {
        'strategy': strategy
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = StrategyResponse;
      return this.apiClient.callApi(
        '/api/v1/strategy/{strategy}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Get Strategy
     * @param {String} strategy 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/StrategyResponse}
     */
    getStrategyApiV1StrategyStrategyGet(strategy) {
      return this.getStrategyApiV1StrategyStrategyGetWithHttpInfo(strategy)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List Strategies
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/StrategyListResponse} and HTTP response
     */
    listStrategiesApiV1StrategiesGetWithHttpInfo() {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = StrategyListResponse;
      return this.apiClient.callApi(
        '/api/v1/strategies', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * List Strategies
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/StrategyListResponse}
     */
    listStrategiesApiV1StrategiesGet() {
      return this.listStrategiesApiV1StrategiesGetWithHttpInfo()
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


}
